
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct {void (*f)(void);} st;  // field f of struct st is a function pointer 

void nothing (){ printf("Nothing\n"); } // a safe function

int main(int argc , char * argv [])
{ 
	st *p1, *p2;
	p1=(st*) malloc(sizeof(st)); // allocates to p1 a block to a struct st 
	p1 ->f=&nothing; // p1->f now points to function nothing()
	p1 ->f();   // executes nothing()
	free(p1);  
	p2=(st*)malloc(sizeof(st)); 
	p2->f=(void(*)(void)) (argv[1]); // p2->f now points to buffer argv[1]
	p1->f();  
	return 0;
}
